## vtkedge 0.2.0~20110819

=== CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================


# -----------------------------------------------------------------------------
# Set the minimum required cmake version. Setting here to 2.4, but really
# 2.7 is required for testing with bullseye coverage. Will change to 2.8 once
# it is officially released
# -----------------------------------------------------------------------------
cmake_minimum_required(VERSION 2.4)
project(VTKEdge)

# -----------------------------------------------------------------------------
# Set cmake policy CMP0003 to NEW. This means cmake will not break up linked
# libraries into separate linker search paths and library names.
# -----------------------------------------------------------------------------
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND CMAKE_POLICY)

# -----------------------------------------------------------------------------
# VTKEdge version number.  An even minor number corresponds to a release
# -----------------------------------------------------------------------------
set(VTKEdge_VERSION_MAJOR 0)
set(VTKEdge_VERSION_MINOR 1)
set(VTKEdge_VERSION_BUILD 0)
set(VTKEdge_VERSION
  "${VTKEdge_VERSION_MAJOR}.${VTKEdge_VERSION_MINOR}.${VTKEdge_VERSION_BUILD}")

# -----------------------------------------------------------------------------
# Setup the output paths
# Remark:
# Make sure this section appears before FIND_PACKAGE(VTK) statement.
# In case FIND_PACKAGE(VTK) statement is used before the following lines and
# fails for any reason, EXECUTABLE_OUTPUT_PATH is set to empty, as it is a
# cached variable there would be no change it takes ${PROJECT_BINARY_DIR}/bin
# as its default value.
# Reminder:
# EXECUTABLE_OUTPUT_PATH is no longer used in Cmake 2.6. The day the minimum
# requirement moves from 2.4 to 2.6, it should be replaced by the use of
# RUNTIME_OUTPUT_DIRECTORY target property.
# -----------------------------------------------------------------------------
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin CACHE PATH
  "Single output directory for building all libraries.")
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin CACHE PATH
  "Single output directory for building all executables.")
mark_as_advanced(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

set(VTKEdge_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})
set(VTKEdge_RUNTIME_DIRS ${LIBRARY_OUTPUT_PATH})

# Set CXX_TEST_PATH, bullet-proof to empty EXECUTABLE_OUTPUT_PATH.
if(EXECUTABLE_OUTPUT_PATH)
  set(CXX_TEST_PATH "${EXECUTABLE_OUTPUT_PATH}")
else(EXECUTABLE_OUTPUT_PATH)
  set(CXX_TEST_PATH ".")
endif(EXECUTABLE_OUTPUT_PATH)

# -----------------------------------------------------------------------------
# Disable deprecation warnings for standard C and STL functions in VS2005 and
# later (no, we don't need IF(CMAKE_COMPILER_2005) ... )
# -----------------------------------------------------------------------------
add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
add_definitions(-D_SCL_SECURE_NO_DEPRECATE)

# -----------------------------------------------------------------------------
# Bring our CMake modules to the CMake path
# -----------------------------------------------------------------------------
set(VTKEdge_CMAKE_DIR "${VTKEdge_SOURCE_DIR}/CMake" CACHE INTERNAL "")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${VTKEdge_CMAKE_DIR}")
add_subdirectory(CMake)

# -----------------------------------------------------------------------------
# Setup the installation settings
# -----------------------------------------------------------------------------

set(VTKEdge_CONFIGURATION_TYPES ${CMAKE_CONFIGURATION_TYPES})

set(VTK_INSTALL_NO_DEVELOPMENT ON) # why?

if(NOT VTKEdge_INSTALL_BIN_DIR)
  set(VTKEdge_INSTALL_BIN_DIR "/bin")
endif(NOT VTKEdge_INSTALL_BIN_DIR)

if(NOT VTKEdge_INSTALL_LIB_DIR)
  set(VTKEdge_INSTALL_LIB_DIR "/lib/${PROJECT_NAME}")
endif(NOT VTKEdge_INSTALL_LIB_DIR)

if(NOT VTKEdge_INSTALL_DATA_DIR)
  set(VTKEdge_INSTALL_DATA_DIR "/share/${PROJECT_NAME}" CACHE INTERNAL "")
endif(NOT VTKEdge_INSTALL_DATA_DIR)

if(NOT VTKEdge_INSTALL_INCLUDE_DIR)
  set(VTKEdge_INSTALL_INCLUDE_DIR "/include/${PROJECT_NAME}")
endif(NOT VTKEdge_INSTALL_INCLUDE_DIR)

if(NOT VTKEdge_INSTALL_PACKAGE_DIR)
  set(VTKEdge_INSTALL_PACKAGE_DIR ${VTKEdge_INSTALL_LIB_DIR} CACHE INTERNAL "")
endif(NOT VTKEdge_INSTALL_PACKAGE_DIR)

if(NOT VTKEdge_VTK_INSTALL_PACKAGE_DIR)
  set(VTKEdge_VTK_INSTALL_PACKAGE_DIR ${VTK_INSTALL_PACKAGE_DIR})
endif(NOT VTKEdge_VTK_INSTALL_PACKAGE_DIR)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  set(VTKEdge_INSTALL_NO_DEVELOPMENT 0)
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

if(NOT VTKEdge_INSTALL_NO_RUNTIME)
  set(VTKEdge_INSTALL_NO_RUNTIME 0)
endif(NOT VTKEdge_INSTALL_NO_RUNTIME)

if(NOT VTKEdge_INSTALL_NO_DOCUMENTATION)
  set(VTKEdge_INSTALL_NO_DOCUMENTATION 0)
endif(NOT VTKEdge_INSTALL_NO_DOCUMENTATION)

set(VTKEdge_INSTALL_NO_LIBRARIES)
if(VTKEdge_BUILD_SHARED_LIBS)
  if(VTKEdge_INSTALL_NO_RUNTIME AND VTKEdge_INSTALL_NO_DEVELOPMENT)
    set(VTKEdge_INSTALL_NO_LIBRARIES 1)
  endif(VTKEdge_INSTALL_NO_RUNTIME AND VTKEdge_INSTALL_NO_DEVELOPMENT)
else(VTKEdge_BUILD_SHARED_LIBS)
  if(VTKEdge_INSTALL_NO_DEVELOPMENT)
    set(VTKEdge_INSTALL_NO_LIBRARIES 1)
  endif(VTKEdge_INSTALL_NO_DEVELOPMENT)
endif(VTKEdge_BUILD_SHARED_LIBS)

# -----------------------------------------------------------------------------
# Include CTest for testing
# -----------------------------------------------------------------------------
include(CTest)

# -----------------------------------------------------------------------------
# Add in the option for building examples, default to ON
# If BUILD_EXAMPLES was set by a larger project, use it.
# -----------------------------------------------------------------------------
option(VTKEdge_BUILD_EXAMPLES "Build VTKEdge examples." ${BUILD_EXAMPLES})

# -----------------------------------------------------------------------------
# Find VTK - it is a required package
# -----------------------------------------------------------------------------
find_package(VTK REQUIRED)
include(${VTK_USE_FILE})


# -----------------------------------------------------------------------------
# Find ITK - it is an optional package that if present allows the usage of
#            complex paintbrush operations in Widgets/ such as flood fill
#            paintbrushes etc.
# If you are using VTKEdge as a subproject within your project, and you want
# to enable/disable the use of ITK, just set VTKEdge_USE_ITK_DEFAULT from your
# top level directory
# -----------------------------------------------------------------------------
SET(default_val 0)
IF(DEFINED VTKEdge_USE_ITK_DEFAULT)
  SET(default_val ${VTKEdge_USE_ITK_DEFAULT})
ENDIF(DEFINED VTKEdge_USE_ITK_DEFAULT)
OPTION(VTKEdge_USE_ITK
  "Build filtered brush widgets that require ITK" ${default_val})
MARK_AS_ADVANCED(VTKEdge_USE_ITK)
IF(VTKEdge_USE_ITK)
  IF(NOT ITK_SOURCE_DIR)
    FIND_PACKAGE(ITK REQUIRED)
    IF(ITK_FOUND)
      INCLUDE(${ITK_USE_FILE})
    ENDIF(ITK_FOUND)
  ENDIF(NOT ITK_SOURCE_DIR)
ENDIF(VTKEdge_USE_ITK)


# -----------------------------------------------------------------------------
# Find CUDA
# -----------------------------------------------------------------------------
option(VTKEdge_USE_CUDA "Use NVIDIAs CUDA library." OFF)
if(VTKEdge_USE_CUDA)
  find_package(Cuda)
endif(VTKEdge_USE_CUDA)

# -----------------------------------------------------------------------------
# Add an option for building shared - default to the same choice made for VTK
# BUILD_SHARED_LIBS is a builtin cmake variable.
# -----------------------------------------------------------------------------
option(BUILD_SHARED_LIBS "Build with shared libraries."
  ${VTK_BUILD_SHARED_LIBS})

# Set VTKEdge_BUILD_SHARED_LIBS to 1 or 0 for use in creating the
# configuration header.
if(BUILD_SHARED_LIBS)
  set(VTKEdge_BUILD_SHARED_LIBS 1)
else(BUILD_SHARED_LIBS)
  set(VTKEdge_BUILD_SHARED_LIBS 0)
endif(BUILD_SHARED_LIBS)

# -----------------------------------------------------------------------------
# Configure VTK_DATA_ROOT for the location of VTKData. VTKData is required for
# some examples and tests. Check this directory, up one, and up two.
# -----------------------------------------------------------------------------
find_path(VTK_DATA_ROOT VTKData.readme
  ${VTKEdge_SOURCE_DIR}/VTKData
  ${VTKEdge_SOURCE_DIR}/../VTKData
  ${VTKEdge_SOURCE_DIR}/../../VTKData
  ${VTKEdge_SOURCE_DIR}/../VTK/VTKData
  ${VTKEdge_SOURCE_DIR}/../../VTK/VTKData
  $ENV{VTK_DATA_ROOT}
  )

# -----------------------------------------------------------------------------
# Enable kits
# -----------------------------------------------------------------------------
set(VTKEdge_AVAILABLE_KITS
  Common
  Filtering
  Hybrid
  Imaging
  IO
  Rendering
  VolumeRendering
  Widgets
  )
set(VTKEdge_ENABLED_KITS)
set(VTKEdge_RELATIVE_INCLUDE_DIRS)

set(libraries)
set(include_paths)

foreach(kit ${VTKEdge_AVAILABLE_KITS})
  if(DEFINED VTKEdge_BUILD_${kit}_KIT_DEFAULT)
    set(default_val ${VTKEdge_BUILD_${kit}_KIT_DEFAULT})
  else(DEFINED VTKEdge_BUILD_${kit}_KIT_DEFAULT)
    set(default_val 1)
  endif(DEFINED VTKEdge_BUILD_${kit}_KIT_DEFAULT)
  option(VTKEdge_BUILD_${kit}_KIT "Build VTKEdge ${kit} kit." ${default_val})
  mark_as_advanced(VTKEdge_BUILD_${kit}_KIT)
  if(VTKEdge_BUILD_${kit}_KIT)
    set(VTKEdge_ENABLED_KITS ${VTKEdge_ENABLED_KITS} ${kit})
    set(libraries ${libraries} vtkKWE${kit})
    set(VTKEdge_RELATIVE_INCLUDE_DIRS ${VTKEdge_RELATIVE_INCLUDE_DIRS} ${kit})
    set(include_paths ${include_paths} ${VTKEdge_SOURCE_DIR}/${kit})
  endif(VTKEdge_BUILD_${kit}_KIT)
endforeach(kit)

set(include_paths ${include_paths} ${PROJECT_BINARY_DIR})

set(VTKEdge_INCLUDE_PATH ${include_paths} CACHE INTERNAL
  "Include paths for VTKEdge")

set(VTKEdge_LIBRARIES ${libraries} CACHE INTERNAL
  "Libraries for VTKEdge")

include_directories(${VTKEdge_INCLUDE_PATH})

# Find the VTK_VERSION_DATE. The widgets have code so as to deal with changes
# in VTK both before and after the Depth peeling compatibility changes.
FIND_FILE(VTK_VERSION_FILENAME "vtkVersion.h" ${VTK_INCLUDE_DIRS})
MARK_AS_ADVANCED(VTK_VERSION_FILENAME)
FILE(READ ${VTK_VERSION_FILENAME} VTK_VERSION_FILE)
FIND_FILE(VTK_DATE_STAMP_FILENAME "vtksys/DateStamp.h" ${VTK_INCLUDE_DIRS})
IF(EXISTS ${VTK_DATE_STAMP_FILENAME})
  FILE(READ ${VTK_DATE_STAMP_FILENAME} VTK_DATE_STAMP_FILE)
  SET( VTK_VERSION_FILE ${VTK_VERSION_FILE} ${VTK_DATE_STAMP_FILE})
ENDIF(EXISTS ${VTK_DATE_STAMP_FILENAME})
STRING(REGEX MATCH "[0-9][0-9][0-9][0-9][/|-][0-9][0-9][/|-][0-9][0-9]"
  VTKEdge_VTK_VERSION_DATE ${VTK_VERSION_FILE})
STRING(REGEX REPLACE "[/|-]" "" VTKEdge_VTK_VERSION_DATE ${VTKEdge_VTK_VERSION_DATE})

# -----------------------------------------------------------------------------
# The configured header file used to pass CMake settings to the source code.
# DO NOT DEFINE ANY OPTION AFTER THIS SECTION
# Here we configure the .in file to form the .h, that is then stored in the
# binary directory - so we'll need to add that in the include path
# As the config file depends on VTKEdge_BUILD_SHARED_LIBS and VTKedge version
# number, make sure to place this statement after them.
# -----------------------------------------------------------------------------
configure_file(

=== CMake/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_PACKAGE_DIR}/CMake "\\.cmake$")
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

=== Common/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

# -----------------------------------------------------------------------------
# Set of basic source files
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWEDataArrayStreamer.cxx
  vtkKWEFunctionToGLSL.cxx
  vtkKWEUUID.cxx
  vtkKWEInformationKeyMap.cxx
  )

# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# Need filtering for now because older VTK has vtkInformationKey in
# vtkFiltering, not vtkCommon. Specifically trying to support
# VolView build which still uses an older version of VTK
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkCommon
  vtkFiltering
  )

# -----------------------------------------------------------------------------
# UUID support
# -----------------------------------------------------------------------------
find_package(UUID)
if(UUID_FOUND)
  set(SYSTEM_UUID_FOUND 1)
  set(KIT_LIBS ${KIT_LIBS} ${UUID_LIBRARIES})
endif(UUID_FOUND)

if(WIN32)
  if (NOT BORLAND)
    # rpcrt4 -> UuidCreate
    #snmpapi -> getting MAC address
    set(KIT_LIBS ${KIT_LIBS} rpcrt4 snmpapi)
  endif(NOT BORLAND)
endif(WIN32)

# Check if header file exists and add it to the list.
include (${CMAKE_ROOT}/Modules/CheckIncludeFiles.cmake)
MACRO(CHECK_INCLUDE_FILE_CONCAT FILE VARIABLE)
  CHECK_INCLUDE_FILES("${KWECommon_INCLUDES};${FILE}" ${VARIABLE})
  if(${VARIABLE})
    set(KWECommon_INCLUDES ${KWECommon_INCLUDES} ${FILE})
  endif(${VARIABLE})
ENDMACRO(CHECK_INCLUDE_FILE_CONCAT)

# Need these headers for GetMacAddress in vtkKWEUUID
# Tricky as you need to figure out the proper order to test the inclusion of files
CHECK_INCLUDE_FILE_CONCAT("unistd.h"       CMAKE_HAVE_UNISTD_H)
CHECK_INCLUDE_FILE_CONCAT("stdlib.h"       CMAKE_HAVE_STDLIB_H)
if(UNIX) #Avoid polluting Win32 cmakecache
  CHECK_INCLUDE_FILE_CONCAT("sys/ioctl.h"    CMAKE_HAVE_SYS_IOCTL_H)
  CHECK_INCLUDE_FILE_CONCAT("sys/socket.h"   CMAKE_HAVE_SYS_SOCKET_H)
  CHECK_INCLUDE_FILE_CONCAT("sys/sockio.h"   CMAKE_HAVE_SYS_SOCKIO_H)
  CHECK_INCLUDE_FILE_CONCAT("net/if.h"       CMAKE_HAVE_NET_IF_H)
  CHECK_INCLUDE_FILE_CONCAT("netinet/in.h"   CMAKE_HAVE_NETINET_IN_H)
  CHECK_INCLUDE_FILE_CONCAT("net/if_dl.h"    CMAKE_HAVE_NET_IF_DL_H)
  CHECK_INCLUDE_FILE_CONCAT("net/if_arp.h"   CMAKE_HAVE_NET_IF_ARP_H)
endif(UNIX)

# Test if os defines a length for sockaddr
# only doing the test when we have sys/socket
if( ${CMAKE_HAVE_SYS_SOCKET_H} )
  if("HAVE_SA_LEN" MATCHES "^HAVE_SA_LEN$")
    STRING(ASCII 35 POUND)
    FILE(WRITE ${PROJECT_BINARY_DIR}/CMakeTmp/kweCommonTestHAVESALEN.c
      "${POUND}include <sys/types.h>\n"
      "${POUND}include <sys/socket.h>\n"
      "int main() { struct sockaddr sa; sa.sa_len = 0; }\n")
    message(STATUS "Checking if ifreq has a sa_len")
    TRY_COMPILE(HAVE_SA_LEN
      ${PROJECT_BINARY_DIR}
      ${PROJECT_BINARY_DIR}/CMakeTmp/kweCommonTestHAVESALEN.c
      OUTPUT_VARIABLE OUTPUT)
    if(HAVE_SA_LEN)
      message(STATUS "Checking if ifreq has a sa_len -- yes")
      set(HAVE_SA_LEN 1 CACHE INTERNAL "Support if ifreq has a sa_len")
      write_file(${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeOutput.log
        "Determining if ifreq has a sa_len"
        "passed with the following output:\n"
        "${OUTPUT}\n" APPEND)
    else(HAVE_SA_LEN)
      message(STATUS "Checking if ifreq has a sa_len -- no")
      set(HAVE_SA_LEN 0 CACHE INTERNAL "Support if ifreq has a sa_len")
      write_file(${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeError.log
        "Determining if ifreq has a sa_len"
        "failed with the following output:\n"
        "${OUTPUT}\n" APPEND)
    endif(HAVE_SA_LEN)
  endif("HAVE_SA_LEN" MATCHES "^HAVE_SA_LEN$")
endif( ${CMAKE_HAVE_SYS_SOCKET_H} )

# The configured header file used to pass CMake settings to the source code.
configure_file(
  "${PROJECT_SOURCE_DIR}/Common/VTKEdgeUUIDConfigure.h.in"
  "${PROJECT_BINARY_DIR}/VTKEdgeUUIDConfigure.h"
  )

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWECommon ${KIT_SRCS})
target_link_libraries(vtkKWECommon ${KIT_LIBS})

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
#if(BUILD_TESTING)
# add_subdirectory(Testing)
#endif(BUILD_TESTING)

# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWECommon
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWECommon" "KWECOMMON" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== Examples/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

# -----------------------------------------------------------------------------
# Just add all the subdirectories
# -----------------------------------------------------------------------------
set(kits
  Filtering
  Hybrid
  Rendering
  )
foreach(kit ${kits})
  if(VTKEdge_BUILD_${kit}_KIT)
    add_subdirectory(${kit})
  endif(VTKEdge_BUILD_${kit}_KIT)
endforeach(kit)

if (VTKEdge_BUILD_Widgets_KIT)
  subdirs( GUI )
endif(VTKEdge_BUILD_Widgets_KIT)

=== Filtering/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================


# -----------------------------------------------------------------------------
# IO is required!
# -----------------------------------------------------------------------------
if(NOT VTKEdge_BUILD_IO_KIT)
  message(FATAL_ERROR "VTKEdge_BUILD_Filtering_KIT requires VTKEdge_BUILD_IO_KIT.")
endif(NOT VTKEdge_BUILD_IO_KIT)

# -----------------------------------------------------------------------------
# Set of basic source files
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWEObjectTreePropertyBase.cxx
  vtkKWEObjectTreeTransformableNode.cxx
  vtkKWEObjectTreeUserProperty.cxx
  vtkKWEObjectTreeNodeBase.cxx
  vtkKWEObjectTreeNodeIterator.cxx
  vtkKWEObjectTreeColorProperty.cxx
  )

set_source_files_properties(
  vtkKWEObjectTreePropertyBase
  ABSTRACT
)

# -----------------------------------------------------------------------------
# List the source files that should not be wrapped.
# -----------------------------------------------------------------------------
#SET_SOURCE_FILES_PROPERTIES(
#
#  WRAP_EXCLUDE)

# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkKWEIO
  )

# -----------------------------------------------------------------------------
# Setup vtkInstantiator registration for this library's classes.
# THIS IS REQUIRED FOR THE SERIALIZATION TO WORK
# -----------------------------------------------------------------------------
INCLUDE(${VTK_CMAKE_DIR}/vtkMakeInstantiator.cmake)
VTK_MAKE_INSTANTIATOR3(vtkKWEFilteringInstantiator FilteringInstantiatorFiles
  "${KIT_SRCS}"
  VTK_EXPORT
  "${CMAKE_CURRENT_BINARY_DIR}" "")

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWEFiltering ${KIT_SRCS} ${KIT_EXTRA_SRCS} ${FilteringInstantiatorFiles})
target_link_libraries(vtkKWEFiltering ${KIT_LIBS})


# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)



# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWEFiltering
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWEFiltering" "KWEFILTERING" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== Graphics/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

# -----------------------------------------------------------------------------
# Set of basic source files (not the OpenGL or GLSL ones)
# -----------------------------------------------------------------------------
set(KIT_SRCS
  )

# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkGraphics
  )

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWEGraphics ${KIT_SRCS})
target_link_libraries(vtkKWEGraphics ${KIT_LIBS})

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)

# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWEGraphics
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWEGraphics" "KWEGRAPHICS" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== Hybrid/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
## 
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

# -----------------------------------------------------------------------------
# Set of basic source files (not the OpenGL or GLSL ones)
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWEExtentCalculator.cxx
  vtkKWEGPUArrayCalculator.cxx
  vtkKWEGPUImageAlgorithmDriver.cxx
  vtkKWEImageGradientMagnitude.cxx
  )

# -----------------------------------------------------------------------------
# List the source files that should not be wrapped.
# -----------------------------------------------------------------------------
#SET_SOURCE_FILES_PROPERTIES(
#
#  WRAP_EXCLUDE)

# -----------------------------------------------------------------------------
# Set of GLSL source files
# -----------------------------------------------------------------------------
set(KIT_GLSL_SRCS
  vtkKWEImageGradientMagnitude_2D_fs
  vtkKWEImageGradientMagnitude_3D_fs
  )

# -----------------------------------------------------------------------------
# Create custom commands to encode each glsl file into a C string literal
# in a header file
# -----------------------------------------------------------------------------

foreach(file ${KIT_GLSL_SRCS})
  set(src ${CMAKE_CURRENT_SOURCE_DIR}/${file}.glsl)
  set(res ${CMAKE_CURRENT_BINARY_DIR}/${file}.cxx)
  add_custom_command(
    OUTPUT ${res}
    DEPENDS ${src}
    COMMAND ${VTK_ENCODESTRING_EXE}
    ARGS ${res} ${src} ${file}
    )
  set(KIT_EXTRA_SRCS ${KIT_EXTRA_SRCS} ${res})
endforeach(file)

# -----------------------------------------------------------------------------
# List the kits that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkHybrid
  vtkKWECommon
  vtkKWERendering
  )

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWEHybrid ${KIT_SRCS} ${KIT_EXTRA_SRCS})
target_link_libraries(vtkKWEHybrid ${KIT_LIBS})

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)

# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWEHybrid
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWEHybrid" "KWEHYBRID" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== IO/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================


# -----------------------------------------------------------------------------
# Set of basic source files
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWECommonSerializationHelper.cxx
  vtkKWESerializableObject.cxx
  vtkKWESerializationHelper.cxx
  vtkKWESerializationHelperMap.cxx
  vtkKWESerializer.cxx
  vtkKWEXMLArchiveReader.cxx
  vtkKWEXMLArchiveWriter.cxx
  vtkKWEXMLElement.cxx
  vtkKWEXMLParser.cxx
  )

set_source_files_properties(
  vtkKWESerializationHelper.cxx
  vtkKWESerializer.cxx
  ABSTRACT
)


# -----------------------------------------------------------------------------
# List the source files that should not be wrapped.
# -----------------------------------------------------------------------------
#SET_SOURCE_FILES_PROPERTIES(
#
#  WRAP_EXCLUDE)


# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkKWECommon
  vtkIO
  )

# -----------------------------------------------------------------------------
# If building Rendering, add help for serialization
# -----------------------------------------------------------------------------
if(VTK_USE_RENDERING)
  set(KIT_EXTRA_SRCS ${KIT_EXTRA_SRCS}
    vtkKWERenderingSerializationHelper.cxx
  )
  set(KIT_LIBS ${KIT_LIBS} vtkRendering)
endif(VTK_USE_RENDERING)

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWEIO ${KIT_SRCS} ${KIT_EXTRA_SRCS})
target_link_libraries(vtkKWEIO ${KIT_LIBS})

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)


# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWEIO
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWEIO" "KWEIO" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== Imaging/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

# -----------------------------------------------------------------------------
# Set of basic source files (not the OpenGL, GLSL or CUDA ones)
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWEImageFDKFilter.cxx
  )

# -----------------------------------------------------------------------------
# Set of source files that call Cuda
# -----------------------------------------------------------------------------
if(CUDA_FOUND AND CUDA_CUTIL_FOUND)
  set(KIT_CUDA_DEPENDANT_SRCS
    vtkKWEImageFFT.cxx
    vtkKWEImageRFFT.cxx
    )
  set(KIT_CUDA_SOURCES
    vtkKWEImageFFT.cu
    vtkKWEImageRFFT.cu
    )
  include_directories(
    ${CUDA_INCLUDE_DIR}
    ${CUDA_CUTIL_INCLUDE_DIR}
    )
  cuda_compile(KIT_CUDA_C_SOURCES ${KIT_CUDA_SOURCES})
endif(CUDA_FOUND AND CUDA_CUTIL_FOUND)

# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkIO
  vtkImaging
  vtkRendering
  vtkVolumeRendering
  )

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
if(KIT_CUDA_C_SOURCES OR KIT_SRCS OR KIT_CUDA_DEPENDANT_SRCS)
  add_library(vtkKWEImaging ${KIT_CUDA_C_SOURCES} ${KIT_SRCS} ${KIT_CUDA_DEPENDANT_SRCS})
  target_link_libraries(vtkKWEImaging ${KIT_LIBS} ${CUDA_LIBRARIES} ${CUDA_CUTIL_LIBRARY})
endif(KIT_CUDA_C_SOURCES OR KIT_SRCS OR KIT_CUDA_DEPENDANT_SRCS)

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)

# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWEImaging
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWEImaging" "KWEImaging" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== ParaViewPlugins/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

option(VTKEdge_BUILD_PARAVIEW_PLUGINS "Build Plugins for ParaView" OFF)
if(VTKEdge_BUILD_PARAVIEW_PLUGINS)
  find_package(ParaView REQUIRED)
  include(${PARAVIEW_USE_FILE})
  set(MOC_SRCS)
  set(UI_SRCS)

  qt4_wrap_cpp(MOC_SRCS
    pqKWEIlluminatedLinesDisplayPanelDecorator.h
    )

  include_directories(${QT_INCLUDES} ${PARAVIEW_GUI_INCLUDE_DIRS}
    ${PARAVIEW_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR}
    )
  set(KWE_Interfaces
    )

  set(KWE_Sources
    pqKWEIlluminatedLinesDisplayPanelDecorator.cxx
    )

  set(SM_SOURCES
    vtkSMKWEIlluminatedLinesRepresentationProxy.cxx
    )

  set(SM_XMLS
    vtkKWERendering.xml
    vtkKWEExtension.xml
    )

  set(PLUGIN_NAME VTKEdge)
  set(CS_WRAP)

  include(${VTKEdge_BINARY_DIR}/Rendering/vtkKWERenderingKit.cmake)
  foreach(class ${VTK_KWERENDERING_CLASSES})
    set(CS_WRAP ${CS_WRAP} ${VTKEdge_SOURCE_DIR}/Rendering/${class}.h)
  endforeach(class)

  include(${VTKEdge_BINARY_DIR}/Hybrid/vtkKWEHybridKit.cmake)
  foreach(class ${VTK_KWEHYBRID_CLASSES})
    set(CS_WRAP ${CS_WRAP} ${VTKEdge_SOURCE_DIR}/Hybrid/${class}.h)
  endforeach(class)

  add_paraview_plugin(${PLUGIN_NAME} "1.0"
    SERVER_MANAGER_SOURCES "${SM_SOURCES};${CS_WRAP}"
    SERVER_MANAGER_XML ${SM_XMLS}
    GUI_INTERFACES ${KWE_Interfaces}
    GUI_SOURCES ${KWE_Sources} ${MOC_SRCS} ${UI_SRCS}
    )

  target_link_libraries(${PLUGIN_NAME}
    vtkKWERendering
    vtkKWEHybrid
    )

endif(VTKEdge_BUILD_PARAVIEW_PLUGINS)

=== Rendering/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
## 
##
##=============================================================================

# -----------------------------------------------------------------------------
# Set of basic source files (not the OpenGL or GLSL ones)
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWEIlluminatedLinesPainter.cxx
  vtkKWERenderingFactory.cxx
  vtkKWEVBOTStripsPainter.cxx
  vtkKWEVertexBufferObject.cxx
  vtkKWEWireframePainter.cxx
  )

# -----------------------------------------------------------------------------
# Set of GLSL source files
# -----------------------------------------------------------------------------
set(KIT_GLSL_SRCS
  vtkKWEIlluminatedLinesPainter_fs
  vtkKWEIlluminatedLinesPainter_vs
  vtkKWEWireframePainter_fs
  vtkKWEWireframePainter_vs
  )

# -----------------------------------------------------------------------------
# Create custom commands to encode each glsl file into a C string literal
# in a header file
# -----------------------------------------------------------------------------

foreach(file ${KIT_GLSL_SRCS})
  set(src ${CMAKE_CURRENT_SOURCE_DIR}/${file}.glsl)
  set(res ${CMAKE_CURRENT_BINARY_DIR}/${file}.cxx)
  add_custom_command(
    OUTPUT ${res}
    DEPENDS ${src}
    COMMAND ${VTK_ENCODESTRING_EXE}
    ARGS ${res} ${src} ${file}
    )
  set(KIT_EXTRA_SRCS ${KIT_EXTRA_SRCS} ${res})
#set(KIT_EXTRA_SRCS ${res}) 
endforeach(file)

# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkRendering
  )

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWERendering ${KIT_SRCS} ${KIT_EXTRA_SRCS})
target_link_libraries(vtkKWERendering ${KIT_LIBS})

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)

# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWERendering
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWERendering" "KWERENDERING" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== VolumeRendering/CMakeLists.txt ===
##=============================================================================
##   This file is part of VTKEdge. See vtkedge.org for more information.
##
##   Copyright (c) 2010 Kitware, Inc.
##
##   VTKEdge may be used under the terms of the BSD License
##   Please see the file Copyright.txt in the root directory of
##   VTKEdge for further information.
##
##   Alternatively, you may see: 
##
##   http://www.vtkedge.org/vtkedge/project/license.html
##
##
##   For custom extensions, consulting services, or training, please
##   this or any other Kitware supported open source project, please
##   contact Kitware at sales@kitware.com.
##
##
##=============================================================================

# -----------------------------------------------------------------------------
# Set of basic source files (not the OpenGL or GLSL ones)
# -----------------------------------------------------------------------------
set(KIT_SRCS
  vtkKWERepresentativeVolumeImageCreator.cxx
  )

# -----------------------------------------------------------------------------
# Set of OpenGL source files
# -----------------------------------------------------------------------------
set(KIT_OpenGL_SRCS
  )

# -----------------------------------------------------------------------------
# Set of GLSL source files
# -----------------------------------------------------------------------------
set(KIT_GLSL_SRCS
  )

# -----------------------------------------------------------------------------
# Create custom commands to encode each glsl file into a C string literal
# in a header file
# -----------------------------------------------------------------------------

foreach(file ${KIT_GLSL_SRCS})
  set(src ${VTKEdge_SOURCE_DIR}/VolumeRendering/${file}.glsl)
  set(res ${VTKEdge_BINARY_DIR}/VolumeRendering/${file}.cxx)
  add_custom_command(
    OUTPUT ${res}
    DEPENDS ${src}
    COMMAND ${VTK_ENCODESTRING_EXE}
    ARGS ${res} ${src} ${file}
    )
  set(KIT_EXTRA_SRCS ${KIT_EXTRA_SRCS} ${res})
endforeach(file)

# -----------------------------------------------------------------------------
# List the kits from VTK that are needed by this project
# -----------------------------------------------------------------------------
set(KIT_LIBS
  vtkVolumeRendering
  vtkKWECommon
  )

# -----------------------------------------------------------------------------
# Create the library
# -----------------------------------------------------------------------------
add_library(vtkKWEVolumeRendering ${KIT_SRCS} ${KIT_OpenGL_SRCS} ${KIT_EXTRA_SRCS})
target_link_libraries(vtkKWEVolumeRendering ${KIT_LIBS})

# -----------------------------------------------------------------------------
# Testing
# -----------------------------------------------------------------------------
if(BUILD_TESTING)
  add_subdirectory(Testing)
endif(BUILD_TESTING)

# -----------------------------------------------------------------------------
# Installation
# -----------------------------------------------------------------------------
if(NOT VTKEdge_INSTALL_NO_LIBRARIES)
  install_targets(
    ${VTKEdge_INSTALL_LIB_DIR}
    RUNTIME_DIRECTORY ${VTKEdge_INSTALL_BIN_DIR}
    vtkKWEVolumeRendering
    )
endif(NOT VTKEdge_INSTALL_NO_LIBRARIES)

if(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)
  install_files(${VTKEdge_INSTALL_INCLUDE_DIR} .h ${KIT_SRCS})
endif(NOT VTKEdge_INSTALL_NO_DEVELOPMENT)

# -----------------------------------------------------------------------------
# This make it easy for other projects to get the list of files etc. in this
# kit.
# -----------------------------------------------------------------------------
include(${VTK_CMAKE_DIR}/vtkExportKit.cmake)
vtk_export_kit2("KWEVolumeRendering" "KWEVOLUMERENDERING" ${CMAKE_CURRENT_BINARY_DIR} "${KIT_SRCS}")

=== debian/changelog ===
vtkedge (0.2.0~20110819-2) unstable; urgency=low

  * Use my @d.o alias
  * Bump Std-Vers to 3.9.3, no changes needed
  * Update VCS urls
  * Remove explicit B-D to libgdcm2-dev, not required anymore
  * Reduce overlinking, fix underlinking

 -- Mathieu Malaterre <malat@debian.org>  Tue, 15 May 2012 11:04:49 +0200

vtkedge (0.2.0~20110819-1) unstable; urgency=low

  * Build upstream from newer svn (20110819)
  * Remove references to old GPL license. Closes: #634739
  * Install *.txx file. Closes: #632861
  * Bump Standard Revision to 3.9.2, no changes needed
  * use hardening compilation flags

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Fri, 19 Aug 2011 17:12:42 +0200

vtkedge (0.2.0~20110403-1) unstable; urgency=low

  [ Andreas Tille ]
  * debian/source/format: 3.0 (quilt)
  * Debhelper 8 (control+compat)

  [ Mathieu Malaterre ]
  * Use vtkedge from svn trunk to build against VTK 5.6. Closes: #618183
  * Copyright change from GPL to BSD
  * Manually change the cmake version to reflect ABI change

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Sun, 03 Apr 2011 22:16:29 +0200

vtkedge (0.1.0-3) unstable; urgency=low

  [ Charles Plessy ]
  * Pass --no-name to gzip in order to generate stable MD5 sums
    (debian/get-orig-source).

  [ Mathieu Malaterre ]
  * Fix VTKEdgeConfig.cmake points to wrong location for UseVTKEdge.cmake
    (Closes: #590843)
  * Update Standards-Version to 3.9.1 (no change needed)
  * Remove paraview plugin since not compatible with ParaView 3.8

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 19 Aug 2010 10:00:01 +0200

vtkedge (0.1.0-2) unstable; urgency=low

  * Team upload.

  [ Mathieu Malaterre ]
  * Fix lintian error : missing-build-dependency. No change required
  * Add paraview and ITK plugins

  [ Charles Plessy ]
  * debian/control:
    - Allow Mathieu to upload, by setting DM-Upload-Allowed to ‘yes’.
    - Tighten the build-dependancy on cmake >= 2.8.1.

 -- Charles Plessy <plessy@debian.org>  Mon, 24 May 2010 13:17:07 +0900

vtkedge (0.1.0-1) unstable; urgency=low

  * Initial release (Closes: #551978)

 -- Mathieu Malaterre (malat) <mathieu.malaterre@gmail.com>  Fri, 26 Feb 2010 15:29:32 +0100

=== debian/control ===
Source: vtkedge
Homepage: http://www.vtkedge.org/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.1), libvtk5-dev (>= 5.6),
 libinsighttoolkit3-dev,
 qt4-dev-tools, qt4-qmake, libqt4-dev, libqtwebkit-dev | libqt4-dev (<< 4.7)
Standards-Version: 3.9.3
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/vtkedge/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/vtkedge/trunk/

Package: libvtkedge
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library of advanced visualization and data processing techniques - runtime
 VTKEdge is a library of advanced visualization and data processing techniques
 that complement the Visualization Toolkit (VTK), as well as custom modules to
 allow the use of these techniques within ParaView. VTKEdge does not replace
 VTK, but rather is built alongside VTK to provide additional functionality.
 VTKEdge is available as open source under the BSD licensing terms.
 This new toolkit was created by Kitware in order to
 provide the open source visualization community with access to some of our
 latest technology, while still meeting the commercialization requirements of
 the government contracts that funded the research and development effort.
 .
 This package contains the libraries needed to run VTKEdge applications.

Package: libvtkedge-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libvtkedge (= ${binary:Version})
Description: Library of advanced visualization and data processing techniques - development
 VTKEdge is a library of advanced visualization and data processing techniques
 that complement the Visualization Toolkit (VTK), as well as custom modules to
 allow the use of these techniques within ParaView. VTKEdge does not replace
 VTK, but rather is built alongside VTK to provide additional functionality.
 VTKEdge is available as open source under the BSD licensing terms.
 This new toolkit was created by Kitware in order to
 provide the open source visualization community with access to some of our
 latest technology, while still meeting the commercialization requirements of
 the government contracts that funded the research and development effort.
 .
 This package contains the development files needed to build your own
 VTKEdge applications.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --parallel

# testing does not work as we deactivate rpath during conf time
CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
	-DVTK_DATA_ROOT:PATH=/usr/share/VTKData \
	-DCMAKE_SKIP_RPATH:BOOL=YES \
	-DBUILD_TESTING:BOOL=OFF \
	-DVTKEdge_BUILD_PARAVIEW_PLUGINS:BOOL=OFF \
	-DVTKEdge_USE_ITK:BOOL=ON
	# if anyone has an nvidia card...
	# -DVTKEdge_USE_CUDA:BOOL=ON -DVTKEdge_USE_NVCONTROL:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

get-orig-source:
	./debian/get-orig-source
